#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: julien de Rosny (c) Insitut Langevin/CNRS/ESPCI
"""
import pydicom
import os

def readdicomvolume(direct):
        nb = len([name for name in os.listdir(direct) if os.path.isfile(os.path.join(direct, name))])
        digits = int(log(nb)/log(10))+1
        fileName = lambda i:('%s/MRIm%0'+str(digits)+'d.dcm')%(direct,i)
        a = pydicom.dcmread(fileName(1))
        mat =a.pixel_array
        imag = zeros((mat.shape[0],mat.shape[1],nb),dtype = mat.dtype)
        x = arange(mat.shape[0])*spacing[0]
        y = arange(mat.shape[1])*spacing[1]
        z = a.SliceThickness * arange(nb)
        for i in range(nb):
            a= pydicom.dcmread(fileName(i+1))
            imag[:,:,i] = a.pixel_array
        
        return(imag,x,y,z)

# Read phantom data (see fig 5)        
oc,x,y,z =  readdicomvolume('phantom/opencage')       
bc,x,y,z =  readdicomvolume('phantom/birdcage')       

figure(1)
subplot(1,2,1)
pcolor(y,x,oc[:,:,31]);
title('opencage')
subplot(1,2,2)
pcolor(y,x,bc[:,:,31]);
title('birdcage')

figure(2)
subplot(2,1,1)
pcolor(z[:128],x,oc[:,31,:128]);
title('opencage')
subplot(2,1,2)
pcolor(z[:128],x,bc[:,31,:128]);
title('birdcage')

# Read in_vivo data (see fig 5)        

oc,x,y,z =  readdicomvolume('in_vivo/opencage')       
bc,x,y,z =  readdicomvolume('in_vivo/birdcage')       

figure(1)
subplot(1,2,1)
pcolor(y,x,oc[:,:,31]);
title('opencage')
subplot(1,2,2)
pcolor(y,x,bc[:,:,31]);
title('birdcage')

figure(2)
subplot(2,1,1)
pcolor(z[:128],x,oc[:,31,:128]);
title('opencage')
subplot(2,1,2)
pcolor(z[:128],x,bc[:,31,:128]);
title('birdcage')